/*
 *  ngtk/c/ngtk_getxtbox.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

void ngtk_getxtbox(int height, int width, int top, int left,
				   int bandlen, int virtlen,
				   int boxpair, int boxattr, int textpair, int textattr,
				   int prtpair1, int prtattr1, int prtpair2, int prtattr2,
				   char *title, char *prompt, char *str)
{
	ngtk_win_t *textbox;

    textbox = ngtk_mkbox(height, width, top, left, boxpair, boxattr, title, 0, 1, 0);

    wmove(textbox->win, 1, 2);
    ngtk_dccprintf(textbox, prtpair1, prtattr1, prtpair2, prtattr2, prompt);
	ngtk_minibox(textbox, 3, bandlen+1, 2, 1, 1, 0, 1);

	ngtk_virt_read_win(bandlen, virtlen, top+3, left+2, textpair, textattr, str);

	curs_set(textbox->cursor_flag);
    ngtk_pop_win(textbox);
}

void ngtk_auto_pos_getxtbox(int height, int width,
							int bandlen, int virtlen,
							int boxpair, int boxattr, int textpair, int textattr,
							int prtpair1, int prtattr1, int prtpair2,
							int prtattr2, char *title, char *prompt, char *str)
{
    int top = (LINES / 2) - (height / 2);
    int left = (COLS / 2) - (width / 2);

	ngtk_getxtbox(height, width, top, left, bandlen, virtlen, boxpair, boxattr,
				  textpair, textattr, prtpair1, prtattr1, prtpair2, prtattr2,
				  title, prompt, str);
}

void ngtk_auto_size_getxtbox(int top, int left, int bandlen, int virtlen,
							 int boxpair, int boxattr, int textpair, int textattr,
							 int prtpair1, int prtattr1, int prtpair2,
							 int prtattr2, char *title, char *prompt, char *str)
{
    int height = 6;
    int width = bandlen + 4;

	ngtk_getxtbox(height, width, top, left, bandlen, virtlen, boxpair, boxattr,
				  textpair, textattr, prtpair1, prtattr1, prtpair2, prtattr2,
				  title, prompt, str);
}

void ngtk_auto_getxtbox(int bandlen, int virtlen, int boxpair, int boxattr,
						int textpair, int textattr,
						int prtpair1, int prtattr1, int prtpair2,
						int prtattr2, char *title, char *prompt, char *str)
{
    int height = 6;
    int width = bandlen + 4;
    int top = (LINES / 2) - (height / 2);
    int left = (COLS / 2) - (width / 2);

	ngtk_getxtbox(height, width, top, left, bandlen, virtlen, boxpair, boxattr,
				  textpair, textattr, prtpair1, prtattr1, prtpair2, prtattr2,
				  title, prompt, str);
}
